function varargout=change_simulation_parameters(parameterfile)
delim=':';
lineheight=1.5;
usestrings=0;
h=figure(11);
clf
% change last entry in the brackets and the value of ypos [120 10 80 46]
% [x of lower left corner, y of ll corner, x width, y width]
set(h,'units','characters','position',[100 10 77 40],...
    'numbertitle','off','name','Edit simulation parameters','Visible','on')

[Text,Values]=textread(parameterfile,'%s %s','delimiter',delim);
xpos0=4;    % x start position of text in the figure
ypos=38;    % y start position of text in the figure
flags=false;
%xadd=35;
xadd=45;
for i=1:length(Text)
    text=Text{i};
    if (strcmp(text,'RAVE input file name')|strcmp(text,'JAS3 input file name'))
        usestrings(i)=1;
        values=Values{i};
    else
        usestrings(i)=0;
        values=str2num(Values{i});
    end
    if ~isempty(strfind(text,'Start'))
        xpos=xpos0;
        ypos=ypos-1.5*lineheight;
        htext=uicontrol(h,'style','text','units','characters',...
            'position',[xpos ypos 50 lineheight],...
            'string','Start parameter range',...
            'fontname','courier','fontsize',9,...
            'horizontalalignment','left','backgroundcolor',[0.8 0.8 0.8]);
        %{
        xpos=xpos+xadd;
        htext=uicontrol(h,'style','text','units','characters',...
            'position',[xpos ypos 10 lineheight],...
            'string','Min',...
            'fontname','courier','fontsize',9,...
            'horizontalalignment','center','backgroundcolor',[0.8 0.8 0.8]);
        xpos=xpos+10;
        htext=uicontrol(h,'style','text','units','characters',...
            'position',[xpos ypos 10 lineheight],...
            'string','Max',...
            'fontname','courier','fontsize',9,...
            'horizontalalignment','center','backgroundcolor',[0.8 0.8 0.8]);
            %}
        ypos=ypos-0.5*lineheight;
    end
    if ~isempty(strfind(text,'Flags'))
        flags=true;
        xpos=xpos0;
        ypos=ypos-1.5*lineheight;
        htext=uicontrol(h,'style','text','units','characters',...
            'position',[xpos ypos 50 lineheight],...
            'string',text,...
            'fontname','courier','fontsize',9,...
            'horizontalalignment','left','backgroundcolor',[0.8 0.8 0.8]);
        ypos=ypos-0.5*lineheight;
    end
    if ~isempty(strfind(text,'Simulation'))
        xpos=xpos0+2;
        ypos=ypos-lineheight;
        htext=uicontrol(h,'style','text','units','characters',...
            'position',[xpos ypos 50 lineheight],...
            'string',text,...
            'fontname','courier','fontsize',9,...
            'horizontalalignment','left','backgroundcolor',[0.8 0.8 0.8]);
    %    ypos=ypos-lineheight;
    end
    if ~isempty(strfind(text,'Reconstruction'))
        xpos=xpos0+2;
        ypos=ypos-lineheight;
        htext=uicontrol(h,'style','text','units','characters',...
            'position',[xpos ypos 50 lineheight],...
            'string',text,...
            'fontname','courier','fontsize',9,...
            'horizontalalignment','left','backgroundcolor',[0.8 0.8 0.8]);
    %    ypos=ypos-lineheight;
    end
    if ~isempty(strfind(text,'Output'))
        xpos=xpos0+2;
        ypos=ypos-lineheight;
        htext=uicontrol(h,'style','text','units','characters',...
            'position',[xpos ypos 50 lineheight],...
            'string',text,...
            'fontname','courier','fontsize',9,...
            'horizontalalignment','left','backgroundcolor',[0.8 0.8 0.8]);
        %ypos=ypos-lineheight;
    end
    if usestrings(i)
        xpos=xpos0;
        ypos=ypos-lineheight;
        htext=uicontrol(h,'style','text','units','characters',...
            'position',[xpos ypos 50 lineheight],...
            'string',text,...
            'fontname','courier','fontsize',9,...
            'horizontalalignment','left','backgroundcolor',[0.8 0.8 0.8]);
        xpos=xpos+xadd;
        hedit(i,1)=uicontrol(h,'style','edit','units','characters',...
                'string',values,...
                'position',[xpos ypos+0.5 25 lineheight],...
                'fontname','courier','fontsize',9,...
                'horizontalalignment','left');
        hedit(i,2)=0;
        %{
    elseif length(values)==2
        boxwidth=12.5;
        xpos=xpos0;
        ypos=ypos-lineheight;
        htext=uicontrol(h,'style','text','units','characters',...
            'position',[xpos ypos 50 lineheight],...
            'string',text,...
            'fontname','courier','fontsize',9,...
            'horizontalalignment','left','backgroundcolor',[0.8 0.8 0.8]);
        xpos=xpos+xadd;
        hedit(i,1)=uicontrol(h,'style','edit','units','characters',...
            'string',num2str(values(1)),...
            'position',[xpos ypos+0.5 boxwidth lineheight],...
            'fontname','courier','fontsize',9,...
            'horizontalalignment','left');
        xpos=xpos+boxwidth;
        hedit(i,2)=uicontrol(h,'style','edit','units','characters',...
            'string',num2str(values(2)),...
            'position',[xpos ypos+0.5 boxwidth lineheight],...
            'fontname','courier','fontsize',9,...
            'horizontalalignment','left');
    elseif length(values)==1
        %}        
    elseif length(values)>0
        if flags
            xpos=xpos0+9;
        else
            xpos=xpos0;
        end
        
        ypos=ypos-lineheight;
        htext=uicontrol(h,'style','text','units','characters',...
            'position',[xpos ypos 50 lineheight],...
            'string',text,...
            'fontname','courier','fontsize',9,...
            'horizontalalignment','left','backgroundcolor',[0.8 0.8 0.8]);
        if flags
            xpos=xpos+xadd;
            hedit(i,1)=uicontrol(h,'style','radiobutton','units','characters',...
                'value',values(1),...
                'position',[xpos ypos+0.5 3 lineheight]);
        else
            xpos=xpos+xadd;
            hedit(i,1)=uicontrol(h,'style','edit','units','characters',...
                'string',num2str(values),...
                'position',[xpos ypos+0.5 25 lineheight],...
                'fontname','courier','fontsize',9,...
                'horizontalalignment','left');
        end
        hedit(i,2)=0;
    end
end
xpos=xpos0;
ypos=ypos-2*lineheight;
hok=uicontrol(h,'style','pushbutton','units','characters',...
    'position',[xpos ypos+0.5 10 lineheight],...
    'string','OK',...
    'tag','okbutton',...
    'fontname','courier','fontsize',12,...
    'horizontalalignment','left',...
    'callback',{@store_simulation_parameters,parameterfile,usestrings});

% Choose default command line output_control for LIC_Detector_Toy
handles.output = h;

handles.hedit=hedit;
handles.Text=Text;
handles.Values=Values;

% Update handles structure
guidata(h, handles);

varargout{1}=hok;

% UIWAIT makes LIC_Detector_Toy wait for user response (see UIRESUME)
% uiwait(handles.figure1);

return

% --- Outputs from this function are returned to the command line.
function varargout = edit_simulation_parameters_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output_control args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output_control from handles structure
varargout{1} = handles.output;
return


